using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;

using System.Web.UI.HtmlControls;
using System.IO;
using System.Collections;
using System.Collections.Specialized;
using System.Text.RegularExpressions;
using System.Text;
/// <summary>
/// Summary description for UtilityBLL
/// </summary>
public class UtilityBLL
{
	public UtilityBLL()
	{}

    public static string ReplaceSpaceWithUnderscore(string input)
    {
        string str = "";
        // replace all  spaces with underscrore
        str = Regex.Replace(input, " ", "_");
        // remove special characters
        return Regex.Replace(str, @"[\[\]\\\^\$\.\/\|\?\*\+\(\)\{\}%,:'""`;><!@#&\+]?", "");
    }

    public static string ReplaceSpaceWithHyphin(string input)
    {
        string str = "";
        // replace all spaces with hypin
        str  = Regex.Replace(input, " ", "-");
        str = Regex.Replace(str, @"[\-]+", "-");
        // remove special characters
        // str = Regex.Replace(str, @"[\[\]\\\^\$\.\|\/\?\*\+\(\)\{\}%,:'""`;><!@#&\+]?", "");
        Regex r = new Regex("(?:[^a-z0-9-_]|(?<=['\"])s)", RegexOptions.IgnoreCase | RegexOptions.CultureInvariant | RegexOptions.Compiled);
        return r.Replace(str, String.Empty);
        //str = Regex.Replace(str, @"^[\w\d:#@%/;$()~_?\+-=\\\.&]", "");
        //return str;
    }
    // without (.) filter using in tags, categories
    public static string ReplaceSpaceWithHyphin_v2(string input)
    {
        string str = "";
        // replace all spaces with hypin
        str = Regex.Replace(input, " ", "-");
        str = Regex.Replace(str, @"[\-]+", "-");
        // remove special characters
        // str = Regex.Replace(str, @"[\[\]\\\^\$\|\/\?\*\+\(\)\{\}%,:'""`;><!@#&\+]?", "");
        Regex r = new Regex("(?:[^a-z0-9-._]|(?<=['\"])s)", RegexOptions.IgnoreCase | RegexOptions.CultureInvariant | RegexOptions.Compiled);
        return r.Replace(str, String.Empty);
    }

    public static string ReplaceHyphinWithSpace(string input)
    {
        string str  = Regex.Replace(input, @"[\-]", " ");
        return str;
    }

    public static string Strip_Special_Characters(string str)
    {
        return Regex.Replace(str, @"[\[\]\\\^\$\.\|\/\?\*\+\(\)\{\}%,:'""`;><!@#&\+]?", "");
    }

    public static string Strip_Search_Characters(string str)
    {
        return Regex.Replace(str, @"[\[\]\\\^\$\|\/\?\*\(\)\{\}%,:'""`;><!@#&\+]?", "");
    }

    public static string Strip_RSS_Characters(string str)
    {
        return Regex.Replace(str, "nbsp|amp", " ");
    }
 
    public static string Add_NoFollow_Tag(string input)
    {
        return Regex.Replace(input, "<a", "<a rel='nofollow'");
    }

    // replace [p] with page number value
    public static string Add_PageNumber(string input, string value)
    {
        return Regex.Replace(input, @"\[p\]", value);
    }

    // apple -> a***e
    public static string Restrict_Word(string word)
    {
        int length = word.Length;
        int count = 0;
        StringBuilder str = new StringBuilder();
        foreach (char c in word)
        {
            if (count > 0 && count < length-1)
              str.Append("*");
            else
              str.Append(c);
           
            count++;
        }
        return str.ToString();
    }
        
    public static string StripHTML(string htmlstring)
    {
        // string pattern = @"<(.|\n)*?>";
        string pattern = @"</?(?i:script|embed|object|font|div|span|p|frameset|frame|iframe|meta|link|style)(.|\n)*?>";
        htmlstring = Regex.Replace(htmlstring, pattern, string.Empty);
        return Regex.Replace(htmlstring, @"<[^>]+>", "");
       //  str = Regex.Replace(str, @"</?(?i:script|embed|object|frameset|frame|iframe|meta|link|style)(.|\n)*?>", "");
       // return str;
    }

    public static string RemoveImages(string htmlstring)
    {
        string pattern = @"</?(?i:img)(.|\n)*?>";
        return Regex.Replace(htmlstring, pattern, string.Empty);
    }

   

    // strip html except <p>
    public static string StripHTML_v2(string htmlstring)
    {      
        string pattern = @"</?(?i:script|font|span|frameset|frame|iframe|meta|link|style)(.|\n)*?>";
        return Regex.Replace(htmlstring, pattern, string.Empty);
    }

    // match urls and replace it with <a href="" /> urls
    public static string Prepare_Urls(string html)
    {
        string tStr = html;
        string http_url = "";
        string short_url = "";
        string http_pattern = @"(\[)(?<url>(http(s)?):(([a-zA-Z0-9._\\\.\/\?\+\%#&\+-=])+)?)(\])"; // match url [http://www.abc.com] , [] is used to protect urls used within src or href urls
        Match VDMatch = Regex.Match(html, http_pattern);
        while (VDMatch.Success)
        {
            http_url = VDMatch.Groups["url"].Value;
            //http_url = VDMatch.Value;
            if (http_url.Length > 50)
                short_url = http_url.Substring(0, 50) + "...";
            else
                short_url = http_url;

            tStr = tStr.Replace(http_url, "<a href=\"" + http_url + "\" target=\"_blank\" rel=\"nofollow\">" + short_url + "</a>");
            tStr = tStr.Replace(@"[","");
            tStr = tStr.Replace(@"]","");
            VDMatch = VDMatch.NextMatch();
        }
        return tStr;
    }

    public static ArrayList Extract_JPEGS(string input)
    {
       RegexOptions m_options = RegexOptions.IgnoreCase | RegexOptions.Multiline | RegexOptions.Singleline;
       Regex regexMatch = new Regex("<img[^>]+>|<a[^>]+>", m_options);
       // Regex regexMatch = new Regex(@"https?://(?:[a-z 0-9\-]+\.)+[a-z]{2,6}(?:/[^/#?]+)+\.(?:jpg|jpeg)", m_options);
       ArrayList arr = new ArrayList();
       Match m = regexMatch.Match(input);
       while (m.Success)
       {
           arr.Add(m.Value);
           input = input.Replace(m.Value, "done");
           m = regexMatch.Match(input);
       }
       return arr;
    }

    public static string CleanBlogHTML(string html)
    {
        html = System.Text.RegularExpressions.Regex.Replace(html, @"<(.|\n)*?>", ""); // remove <.... >
        html = System.Text.RegularExpressions.Regex.Replace(html, @"(\[(\w)+\]([a-zA-Z0-9_\\\^\$\.\/\|\?\*\+\(\)\{\}%,:'""`\;>!@#&\+\s-?])+(\[/(\w)+\]))", ""); // remove [abc]...[/abc]
        return Regex.Replace(html, @"[\[\]\\\^\$\|\/\?\*\+\(\)\{\}%,:'""`;><!@#&\+]?", "");
    }
     

    public static string CleanSearchTerm(string html)
    {
        html = System.Text.RegularExpressions.Regex.Replace(html, @"<(.|\n)*?>", ""); // remove <.... >
        //return System.Text.RegularExpressions.Regex.Replace(html, @"(\[(\w)+\]([a-zA-Z0-9_\\\^\$\.\/\|\?\*\+\(\)\{\}%,:'""\;>!@#&\+\s-?])+(\[/(\w)+\]))", ""); // remove [abc]...[/abc]
        return Regex.Replace(html, @"[\[\]\\\^\$\|\/\?\*\(\)\{\}%,:'""`;><!@#&\+]?", "");
    }

  
    public static string FixCode(string html)
    {
        html = html.Replace("  ", "&nbsp; ");
        html = html.Replace("  ", " &nbsp;");
        html = html.Replace("\t", "&nbsp;&nbsp;&nbsp;");
        html = html.Replace("[", "&#91;");
        html = html.Replace("]", "&#93;");
        html = html.Replace("<", "&lt;");
        html = html.Replace(">", "&gt;");
        html = html.Replace("\n\n\n\n", "<br /><br />");
        html = html.Replace("\n\n\n", "<br /><br />");
        html = html.Replace("\n\n", "<br /><br />");
        html = html.Replace("\n", "<br />");

        // href
        html = Prepare_Urls(html);

        return html;
    }

    public static string CompressCode(string html)
    {
        html = html.Replace("  ", "");
        html = html.Replace("\t", "");
        html = html.Replace("\n\n\n\n", "");
        html = html.Replace("\n\n\n", "");
        html = html.Replace("\n\n", "");
        html = html.Replace("\n", "");
        return html;
    }

    public static string CompressCodeBreak(string html)
    {
        html = html.Replace("  ", "");
        html = html.Replace("\t", "");
        html = html.Replace("\n\n\n\n", "<br />");
        html = html.Replace("\n\n\n", "<br />");
        html = html.Replace("\n\n", "<br />");
        html = html.Replace("\n", "<br />");
        return html;
    }

    public static string UppercaseFirst(string s, bool isallcharacters)
    {
        StringBuilder str = new StringBuilder();
        if (isallcharacters)
        {
            if (s.Contains(" "))
            {
                string[] arr = s.ToString().Split(char.Parse(" "));
                int i;
                for (i = 0; i <= arr.Length - 1; i++)
                {
                    if (arr[i].ToString().Length > 0)
                    {
                        str.Append(UppercaseFirst(arr[i].ToString()) + " ");
                    }
                }
            }
            else
            {
                str.Append(UppercaseFirst(s));
            }
        }
        else
        {
            str.Append(UppercaseFirst(s));
        }
        return str.ToString();
    }

    public static string UppercaseFirst(string s)
    {
        // Check for empty string.
        if (string.IsNullOrEmpty(s))
        {
            return string.Empty;
        }
        // Return char and concat substring.
        return char.ToUpper(s[0]) + s.Substring(1);
    }
}
